#pragma once


#include <Navigation/libraries/client/services/EventSubscriptionInterface.h>


namespace armarx::nav::client
{

    class MemorySubscriber : virtual public EventSubscriptionInterface
    {

    public:
        void onMovementStarted(const OnMovementStartedCallback& callback) override;
        void onGoalReached(const OnGoalReachedCallback& callback) override;

        void onWaypointReached(const OnWaypointReachedCallback& callback) override;

        void
        onSafetyThrottlingTriggered(const OnSafetyThrottlingTriggeredCallback& callback) override;

        void onSafetyStopTriggered(const OnSafetyStopTriggeredCallback& callback) override;

        void onUserAbortTriggered(const OnUserAbortTriggeredCallback& callback) override;

        void onInternalError(const OnInternalErrorCallback& callback) override;

        // Non-API.
    public:
        ~MemorySubscriber() override = default;
    };

} // namespace armarx::nav::client
