/*
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Rainer Kartmann ( rainer dot kartmann at kit dot edu )
 * @date       2021
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#include "utils.h"

#include <QTableWidget>

#include <set>


namespace armarx::nav::locgrapheditor
{

    const QString utils::arrowLeft = QStringLiteral("←");
    const QString utils::arrowRight = QStringLiteral("\u2192");
    const QString utils::arrowBoth = QStringLiteral("⇄");


    QList<QTableWidgetItem*>
    utils::getSelectedItemsOfColumn(QTableWidget* widget, int column)
    {
        std::set<QTableWidgetItem*> set;
        for (QTableWidgetItem* selected : widget->selectedItems())
        {
            if (widget->column(selected) != column)
            {
                selected = widget->item(widget->row(selected), 0);
            }
            set.insert(selected);
        }

        QList<QTableWidgetItem*> list;
        for (auto i : set)
        {
            list.append(i);
        }
        return list;
    }

}
